//
// Parameters
//

typedef unsigned char byte;

// A pixel needs to be at diffrent from its neighbors by at least 'P1'
// in order for it to be considered noise.  The surrending pixels must
// be diffrent by at lease 'P2' in order for the pixel to be
// considered part of the same speck.
extern byte P1;
extern byte P2;

// A speck can be no larger than PWIDTH x PHEIGHT
extern short PWIDTH;
extern short PHEIGHT;

extern int Y_NEXT; // 1 if it is not interlaced, 2 otherwise

// A pixel needs to be diffrent from the previous frame by at least
// 'MTHRES' in order tobe considered moving.  This number should
// be larger than 'P2' in order to prevent noise from being identified
// by motion.
extern byte MTHRES;

// The next three paramaters control the behavior of the the motion
// map denoising algorithm.
extern int  MWIDTH;
extern int  MHEIGHT;
extern byte MP;

#define M_SEARCH 0 // Search and distroy the noise
#define M_MEDIAN 1 // Apply a simple temperal median filter to non
                   // moving areas of the image
extern int MODE;

#define S_DENOISE 0 // Remove the noise
#define S_MARK    1 // Mark noise by changing the luma value to 'MARK_V'
#define S_MAP     2 // Show a motion map and mark noise
extern int SHOW;
extern byte MARK_V;

// The colors when using S_MAP are varing shades or gray:
// 255 (White): Noise that will be removed
// 159:         Noise that won't be remove because it might be motion
//  95:         Motion map for the current image
//  63:         Motion map for the next frame

// static inline byte min(byte x, byte y) {return x < y ? x : y;}
// static inline byte max(byte x, byte y) {return x > y ? x : y;}

// static inline short min(short x, short y) {return x < y ? x : y;}
// static inline short max(short x, short y) {return x > y ? x : y;}

static inline int min(int x, int y) {return x < y ? x : y;}
static inline int max(int x, int y) {return x > y ? x : y;}

